#!/usr/bin/env python
"""
An animated image
"""
#import matplotlib
#matplotlib.use('GTK')
# NOTE: matplotlib as already been imported
from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas

from pylab import imshow
from pylab import cm
from pylab import axis
from matplotlib.figure import Figure
from pylab import ion
import gobject
import common
import time
import numarray as na
import os

from os import O_WRONLY, O_TRUNC, O_CREAT
from stat import S_IRUSR, S_IWUSR, S_IRGRP, S_IWGRP

class AnimatedImage:
    def __init__(self):
	self.fig1 = Figure(figsize=(256, 256))
        self.a1 = self.fig1.add_subplot(111)
        self.canvas1 = FigureCanvas(self.fig1)
        self.fig1.subplots_adjust(left=0.08,right=0.97,hspace=0.,wspace=0.,top=0.97,bottom=0.04)
        self.plot1Type = '2D image'
        self.plot1OldType = ''
        self.xrow1 = 0
        self.psxrow1 = 0
        self.psxcol1 = 0
    	self.cnt1 = 0
        self.quad1 = [0, 0, 0, 0]
        self.quad1Old = [0, 0, 0, 0]
        self.ps1XSec = 'row'
        self.ps1XSecOld = ''
        self.cmin1, self.cmax1 = 0, common.cols
        self.cmin1Old = 0
        self.cmax1Old = 0
        
	self.fig2 = Figure(figsize=(256, 256))
        self.a2 = self.fig2.add_subplot(111)
        self.canvas2 = FigureCanvas(self.fig2)
        self.fig2.subplots_adjust(left=0.08,right=0.97,hspace=0.,wspace=0.,top=0.97,bottom=0.04)
        self.plot2Type = '2D image'
        self.plot2OldType = ''
        self.xrow2 = 0
        self.psxrow2 = 0
        self.psxcol2 = 0
    	self.cnt2 = 0
        self.quad2 = [0, 0, 0, 0]
        self.quad2Old = [0, 0, 0, 0]
        self.ps2XSec = 'row'
        self.ps2XSecOld = ''
        self.cmin2, self.cmax2 = 0, common.cols
        self.cmin2Old = 0
        self.cmax2Old = 0

    # rmg feb11    
    def get_align_counter(n):
        self.align_counter = n
               
    def updatefig1(self):
        # left plot window
        if self.cnt1 == 0:
            self.plot1OldType = self.plot1Type
            self.ps1XSecOld = self.ps1XSec
            self.cmin1Old = self.cmin1
            self.cmax1Old = self.cmax1
            self.quad1Old = self.quad1
        # check if the type of plot has changed
        if (self.plot1Type != self.plot1OldType) or (self.ps1XSecOld != self.ps1XSec)\
               or (self.cmin1Old != self.cmin1) or (self.cmax1Old != self.cmax1)\
               or (self.quad1Old != self.quad1):
            print "plot1 type changed"
            self.cnt1 = 0
            self.plot1OldType = self.plot1Type
            self.ps1XSecOld = self.ps1XSec
            self.cmin1Old = self.cmin1
            self.cmax1Old = self.cmax1
            self.quad1Old = self.quad1
            self.fig1.clear()
            self.a1 = self.fig1.add_subplot(111)
            self.canvas1.queue_draw()
            
        if self.plot1Type == '2D image':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
        # added aspect="auto" to all imshow. EP 10/11/07
                    self.im1 = self.a1.imshow(common.myArray, cmap=cm.bone, \
                                            interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt1 = 1
        	else:
                    self.im1.set_array(common.myArray)
                self.canvas1.draw()
                
        elif self.plot1Type == 'quadrant mode':
            if common.dataready1 == 1 and common.status1 == 1:
                rmin, rmax, cmin, cmax = self.getQuadrant(self.quad1)
		if self.cnt1 == 0:
                    self.im1 = self.a1.imshow(common.myArray[rmin:rmax, cmin:cmax], \
                                              cmap=cm.bone, \
                                              interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt1 = 1
        	else:
                    self.im1.set_array(common.myArray[rmin:rmax, cmin:cmax])
                self.canvas1.draw()
                
        elif self.plot1Type == 'cross section':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
                    self.line1, = self.a1.plot(common.myArray[self.xrow1, self.cmin1:self.cmax1])
                    self.cnt1 = 1
                else:
                    self.line1.set_ydata(common.myArray[self.xrow1, self.cmin1:self.cmax1])
                    
               # self.a1.dataLim.update_numerix(self.line1.get_xdata(),
               #                                self.line1.get_ydata(),True)
                self.a1.update_datalim_numerix(self.line1.get_xdata(),\
                                                self.line1.get_ydata())

                self.a1.autoscale_view()
                self.canvas1.draw()   # redraw the canvas
                
        elif self.plot1Type == 'power spectrum':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
                    self.im1 = self.a1.imshow(common.psArray, cmap=cm.hot, \
                                            interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt1 = 1
        	else:
                    self.im1.set_array(common.psArray)
                self.canvas1.draw()

        elif self.plot1Type == 'channel':
            if common.dataready1 == 1 and common.status1 == 1:
		if self.cnt1 == 0:
                    if self.ps1XSec == 'row':
                        self.line1, = self.a1.plot(common.fluxArray[self.psxrow1])
                    self.cnt1 = 1
                else:
                    if self.ps1XSec == 'row':
                        self.line1.set_ydata(common.fluxArray[self.psxrow1])  # update the data
                
		#print common.fluxArray[self.psxrow1]
		#print " "
		#print common.fluxArray

                #self.a1.dataLim.update_numerix(self.line1.get_xdata(),
                #                               self.line1.get_ydata(),True)
                self.a1.update_datalim_numerix(self.line1.get_xdata(),\
                                               self.line1.get_ydata())
                self.a1.autoscale_view()
                self.canvas1.draw()   # redraw the canvas
# TEMP SAVE TO FILE  #FB May 2011 commented out, hopefully will improve GUI speed 
#	temppos=os.open("./totalbuffer.dat",O_WRONLY | O_TRUNC | O_CREAT)
#        os.chmod("./totalbuffer.dat",S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP )
#	os.write(temppos,common.fluxArray)
#        os.close(temppos)
 
                
        common.dataready1 = 0
        return True
    
    def updatefig2(self):
        # right plot window
        if self.cnt2 == 0:
            self.plot2OldType = self.plot2Type
            self.ps2XSecOld = self.ps2XSec
            self.cmin2Old = self.cmin2
            self.cmax2Old = self.cmax2
            self.quad2Old = self.quad2
       # check if the type of plot has changed
        if (self.plot2Type != self.plot2OldType) or (self.ps2XSecOld != self.ps2XSec)\
               or (self.cmin2Old != self.cmin2) or (self.cmax2Old != self.cmax2)\
               or (self.quad2Old != self.quad2):
            print "plot2 type changed"
            self.cnt2 = 0
            self.plot2OldType = self.plot2Type
            self.ps2XSecOld = self.ps2XSec
            self.cmin2Old = self.cmin2
            self.cmax2Old = self.cmax2
            self.quad2Old = self.quad2
            self.fig2.clear()
            self.a2 = self.fig2.add_subplot(111)
            self.canvas2.queue_draw()
            
        if self.plot2Type == '2D image':
            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
                    self.im2 = self.a2.imshow(common.myArray, cmap=cm.bone, \
                                            interpolation='nearest', origin='lower', aspect="auto")
                    self.cnt2 = 1
        	else:
                    self.im2.set_array(common.myArray)
                self.canvas2.draw()
                
        elif self.plot2Type == 'quadrant mode':
            if common.dataready2 == 1 and common.status2 == 1:
                rmin, rmax, cmin, cmax = self.getQuadrant(self.quad2)
		if self.cnt2 == 0:
                    self.a2.cla() #clears Figure!
                    self.im2 = self.a2.imshow(common.myArray[rmin:rmax, cmin:cmax], \
                                              cmap=cm.bone, \
                                              interpolation='nearest', origin='lower', aspect="auto")
                    # rmg feb11
                    if self.align_counter != -1:
                    #print self.align_counter
                    #self.a2.text(0.5,0.5,'X',bbox=dict(facecolor='red', alpha=0.5))
                    #self.a2.text(0.5,0.5,'X',color='red')
                    #FB temporary hack to replace rmg code, xtarget_4/6 selection TBD
                        self.a2.text(common.xtarget_6[self.align_counter]-.1,common.ytarget_6[self.align_counter]-.1,'X',color='red')
                        self.cnt2 = 1
        	else:
                    self.im2.set_array(common.myArray[rmin:rmax, cmin:cmax])
                self.canvas2.draw()
                self.cnt2 = 0        
                
        elif self.plot2Type == 'cross section':
            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
                    self.line2, = self.a2.plot(common.myArray[self.xrow2, self.cmin2:self.cmax2])
                    self.cnt2 = 1
                else:
                    self.line2.set_ydata(common.myArray[self.xrow2, self.cmin2:self.cmax2])
          
#                    self.a2.dataLim.update_numerix(self.line2.get_xdata(),self.line2.get_ydata(),True)
                    self.a2.update_datalim_numerix(self.line2.get_xdata(),self.line2.get_ydata())
                self.a2.autoscale_view()
                self.canvas2.draw()   # redraw the canvas

        elif self.plot2Type == 'focus mode':
	    #print "ready to go for focus mode!"
	    # JDM
	    # in order to update text on the image, I found it necessary to re-draw figure each time
	    # thus not taknig advantage of some of the nice animaged Image feature of original code.

            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
		    self.a2.cla() #clears Figure!
		    cliparray = na.clip(common.fmArray,0,1)
                    self.im2 = self.a2.imshow(cliparray , cmap=cm.bone, \
                                            interpolation='nearest', origin='lower', aspect="auto")
		    #ax=self.a2.subplot(111,autoscale_onFalse,xlim=(0,6),ylim=(0,6))
		    ax=self.a2
		    #string1 = '%d,%d%s%d%s%d%s' % (common.fmPeaks[0,0],common.fmPeaks[0,1], chr(13), \
		    # 			    common.fmPeaks[0,2],chr(13),100*common.fmPeaks[0,3],'%')
		    #print string1
		    #print common.fmPeaks[0,4]
		    #print common.fmPeaks[1,4]
                    #print common.fmPeaks[2,4]
                    #print common.fmPeaks[3,4]
		
			
		    ax.text(4,4.5,'%s%d,%d' %('@',common.fmPeaks[0,0],common.fmPeaks[0,1]))
		    ax.text(4,4.75,'%d' %(common.fmPeaks[0,2]))
		    ax.text(4,4,'%d%s' %(100*common.fmPeaks[0,3],'%'))
                    ax.text(4,4.25,'%s%d' %('S:',common.fmPeaks[0,2]/common.fmPeaks[0,3]))

                    ax.text(1,4.5,'%s%d,%d' %('@',common.fmPeaks[1,0],common.fmPeaks[1,1]))
                    ax.text(1,4.75,'%d' %(common.fmPeaks[1,2]))
                    ax.text(1,4,'%d%s' %(100*common.fmPeaks[1,3],'%'))
                    ax.text(1,4.25,'%s%d' %('S:',common.fmPeaks[1,2]/common.fmPeaks[1,3]))

                    ax.text(1,1.5,'%s%d,%d' %('@',common.fmPeaks[2,0],common.fmPeaks[2,1]))
                    ax.text(1,1.75,'%d' %(common.fmPeaks[2,2]))
                    ax.text(1,1,'%d%s' %(100*common.fmPeaks[2,3],'%'))
                    ax.text(1,1.25,'%s%d' %('S:',common.fmPeaks[2,2]/common.fmPeaks[2,3]))

                    ax.text(4,1.5,'%s%d,%d' %('@',common.fmPeaks[3,0],common.fmPeaks[3,1]))
                    ax.text(4,1.75,'%d' %(common.fmPeaks[3,2]))
                    ax.text(4,1,'%d%s' %(100*common.fmPeaks[3,3],'%'))
                    ax.text(4,1.25,'%s%d' %('S:',common.fmPeaks[3,2]/common.fmPeaks[3,3]))

		    #self.line2, = self.a2.plot(common.fmFluxArray[:, 0])
                    self.cnt2 = 1  # this is undone by self.cnt2 = 0 later. JDM
        	else:
                    self.im2.set_array(common.fmArray) # should never do this line now JDM

                self.canvas2.draw()
	        self.cnt2 = 0  #FORCE re-draw each time!


        elif self.plot2Type == 'future':
            if common.dataready2 == 1 and common.status2 == 1:
		if self.cnt2 == 0:
                    if self.ps2XSec == 'row':
                        self.line2, = self.a2.plot(common.psArray[self.psxrow2, :])
                    if self.ps2XSec == 'col':
                        self.line2, = self.a2.plot(common.psArray[:, self.psxcol2])
                        
                    self.cnt2 = 1
                else:
                    if self.ps2XSec == 'row':
                        self.line2.set_ydata(common.psArray[self.psxrow2, :])  # update the data
                    if self.ps2XSec == 'col':
                        self.line2.set_ydata(common.psArray[:, self.psxcol2])  # update the data
                #self.a2.dataLim.update_numerix(self.line2.get_xdata(),
                #                               self.line2.get_ydata(),True)
                self.a2.update_datalim_numerix(self.line2.get_xdata(),\
                                               self.line2.get_ydata())
                self.a2.autoscale_view()
                self.canvas2.draw()   # redraw the canvas
                
        common.dataready2 = 0
        return True

    def getQuadrant(self, qd):
        r = common.rows
        c = common.cols
        arr11 = [0, r/2, 0, c/2]
        arr12 = [r/2, r , 0, c/2]
        arr13 = [0, r/2, c/2, c]
        arr14 = [r/2, r , c/2, c]
        arrs1 = [arr11, arr13, arr12, arr14]

        arr21 = [0, r/2, 0, c]
        arr22 = [0, r , 0, c/2]
        arr23 = [0, r, c/2, c]
        arr24 = [r/2, r , 0, c]
        arrs2 = [arr21, arr23, arr22, arr24]
        
        test = [[1,1,0,0], [1,0,1,0], [0,1,0,1], [0,0,1,1]]
        
        if qd.count(1) in [0, 3, 4]:
            return [0, r, 0, c]

        if qd.count(1) == 1:
            return arrs1[qd.index(1)]

        if qd.count(1) == 2:
            if qd in test:
                return arrs2[test.index(qd)]
            else:
                return [0, r, 0, c]
                
        if qd.count(1) == 3:
            return [0, r, 0, c]
        
        if qd.count(1) == 4:
            return [0, r, 0, c]
