import socket
import numpy as np
import struct
import common


class sMessage:
    def __init__(self):
    	self.typ = 0
	self.length = 0
	self.data = ''

class FTCommands:
    def __init__(self):
        """ constructor, setting initial variables """
	self.dither_freq = 30
	self.dither_amp = 10.5
	self.opdamp = 13.2
	self.dither_smoothfrac = 0.05
        self.dither_delay = 0.0

 	self.search_threshold=np.array([100.,100.,100.,100.,100.,100.])
	self.paddleStep = 1.0
	self.gainPhase=np.array([0.1,0.1,0.1,0.1,0.1,0.1])
	self.gainGDT=np.array([-0.15,-0.15,-0.15,-0.15,-0.15,-0.15])
	self.SNRThrS2SL=np.array([5.,5.,5.,5.,5.,5.])
	self.SNRThrSL2L=np.array([10.,10.,10.,10.,10.,10.])
	self.SNRThrL2SL=np.array([5.,5.,5.,5.,5.,5.])
	self.SNRThrSL2S=np.array([4.,4.,4.,4.,4.,4.])
	self.GDTaccumulate=np.array([20,20,20,20,20,20])

        self.BeamOrder=np.array([0,1,2,3,4,5,4])

	self.ampThr=np.array([200.,200.,200.,200.,200.,200.])
	
	self.toggledBC = np.array([999, 999, 999, 999, 999, 999])
	self.champStatus = np.array([999, 999, 999, 999, 999, 999])
	self.BCRefOffset = np.array([0.,0.,0.,0.,0.,0.])
	self.BCFTOffset = np.array([0.,0.,0.,0.,0.,0.])
	self.delayOffset = np.array([0.,0.,0.,0.,0.,0.])
	
	self.searchMode = np.array([1,1,1,1,1,1])
	self.searchSpeed = np.array([10., 10., 10., 10., 10., 10.])
        self.searchStep0 = np.array([4.0,4.0,4.0,4.0,4.0,4.0])
	
	self.champState = np.array([0, 0, 0, 0, 0, 0])
	self.champSetState = np.array([999, 999, 999, 999, 999, 999])

	self.smessage = sMessage()

    def initSocket(self):
        self.sock = None
	#common.port = 60000
        for res in socket.getaddrinfo(common.host, common.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
		self.sock.settimeout(common.timeout)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'
            

    def updatePZTStructure(self):
        self.initSocket() 
	if self.sock != None:
            c_struct = struct.pack(
                '5f',
                self.dither_freq,
                self.dither_amp,
                self.opdamp,
                self.dither_smoothfrac,
                self.dither_delay,            )       
            strLen = len(c_struct)
            print strLen
            self.sock.send('FT')
            print "sent FT"
            self.sock.send(struct.pack('L',strLen))
            print "sent ", strLen
            self.sock.send(c_struct)
            self.sock.close()

    def updateServoStructure(self):
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                '6f6f6f6f6f6f6i',
                self.gainPhase[0], self.gainPhase[1], self.gainPhase[2],
                self.gainPhase[3], self.gainPhase[4], self.gainPhase[5], 
                self.gainGDT[0], self.gainGDT[1], self.gainGDT[2],
                self.gainGDT[3], self.gainGDT[4], self.gainGDT[5], 
                self.SNRThrS2SL[0], self.SNRThrS2SL[1], self.SNRThrS2SL[2],
                self.SNRThrS2SL[3], self.SNRThrS2SL[4], self.SNRThrS2SL[5], 
                self.SNRThrSL2L[0], self.SNRThrSL2L[1], self.SNRThrSL2L[2],
                self.SNRThrSL2L[3], self.SNRThrSL2L[4], self.SNRThrSL2L[5], 
                self.SNRThrL2SL[0], self.SNRThrL2SL[1], self.SNRThrL2SL[2],
                self.SNRThrL2SL[3], self.SNRThrL2SL[4], self.SNRThrL2SL[5],
                self.SNRThrSL2S[0], self.SNRThrSL2S[1], self.SNRThrSL2S[2],
                self.SNRThrSL2S[3], self.SNRThrSL2S[4], self.SNRThrSL2S[5],
                self.GDTaccumulate[0], self.GDTaccumulate[1], self.GDTaccumulate[2],
                self.GDTaccumulate[3], self.GDTaccumulate[4], self.GDTaccumulate[5],
                )
            print self.gainPhase[0], self.gainPhase[1], self.gainPhase[2], self.gainPhase[3], self.gainPhase[4], self.gainPhase[5], self.gainGDT[0], self.gainGDT[1], self.gainGDT[2], self.gainGDT[3], self.gainGDT[4], self.gainGDT[5], self.SNRThrS2SL[0], self.SNRThrS2SL[1], self.SNRThrS2SL[2], self.SNRThrS2SL[3], self.SNRThrS2SL[4], self.SNRThrS2SL[5],  self.SNRThrSL2L[0], self.SNRThrSL2L[1], self.SNRThrSL2L[2],  self.SNRThrSL2L[3], self.SNRThrSL2L[4], self.SNRThrSL2L[5],self.SNRThrL2SL[0], self.SNRThrL2SL[1], self.SNRThrL2SL[2], self.SNRThrL2SL[3], self.SNRThrL2SL[4], self.SNRThrL2SL[5], self.SNRThrSL2S[0], self.SNRThrSL2S[1], self.SNRThrSL2S[2], self.SNRThrSL2S[3], self.SNRThrSL2S[4], self.SNRThrSL2S[5], self.GDTaccumulate[0], self.GDTaccumulate[1], self.GDTaccumulate[2], self.GDTaccumulate[3], self.GDTaccumulate[4], self.GDTaccumulate[5]
            
            strLen = len(c_struct)
            print strLen
            self.sock.send('CP')
            print "sent CP"
            self.sock.send(struct.pack('L',strLen))
            print "sent ", strLen
            self.sock.send(c_struct)
            self.sock.close()

    
    def updateBeamOrder(self):
        print 'Sending Beam order to server'
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                '7i',
                self.BeamOrder[0], self.BeamOrder[1], self.BeamOrder[2],
                self.BeamOrder[3], self.BeamOrder[4], self.BeamOrder[5],self.BeamOrder[6] 
                )       
            strLen = len(c_struct)
            print strLen
            self.sock.send('BO')
            print "sent BO"
            self.sock.send(struct.pack('L',strLen))
            print "sent ", strLen
            self.sock.send(c_struct)
            self.sock.close()

    def paddleFringe(self, bc, paddleOffset):
	print paddleOffset, bc
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                'id',
                bc, 
                paddleOffset,
                )       
            strLen = len(c_struct)
            print strLen
            self.sock.send('PA')
            print "sent PA"
            self.sock.send(struct.pack('L',strLen))
            print "sent ", strLen
            self.sock.send(c_struct)
            self.sock.close()

    def setSearchParameters(self):
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                '6i6f6d',
                self.searchMode[0], self.searchMode[1], self.searchMode[2],
                self.searchMode[3], self.searchMode[4], self.searchMode[5], 
                self.searchSpeed[0], self.searchSpeed[1], self.searchSpeed[2],
                self.searchSpeed[3], self.searchSpeed[4], self.searchSpeed[5],
                self.searchStep0[0], self.searchStep0[1], self.searchStep0[2],
                self.searchStep0[3], self.searchStep0[4], self.searchStep0[5], 
                )
            strLen = len(c_struct)
            print strLen
            self.sock.send('SS')
            print "sent SS"
            self.sock.send(struct.pack('L',strLen))
            print "sent ", strLen
            self.sock.send(c_struct)
            self.sock.close()
            print self.searchMode[0], self.searchMode[1], self.searchMode[2], self.searchMode[3], self.searchMode[4], self.searchMode[5], self.searchSpeed[0], self.searchSpeed[1], self.searchSpeed[2], self.searchSpeed[3], self.searchSpeed[4], self.searchSpeed[5], self.searchStep0[0], self.searchStep0[1], self.searchStep0[2], self.searchStep0[3], self.searchStep0[4], self.searchStep0[5]
	
    def setAmpThr(self):
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                '6f',
                self.ampThr[0], self.ampThr[1], self.ampThr[2],
                self.ampThr[3], self.ampThr[4], self.ampThr[5]
                )       
            strLen = len(c_struct)
            print strLen
            self.sock.send('AT')
            print "sent AT"
            self.sock.send(struct.pack('L',strLen))
            print "sent ", strLen
            self.sock.send(c_struct)
            self.sock.close()
	
    def calcAmpThr(self, bc):
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                'i',
                bc
                )       
            self.sock.settimeout(30)
            self.sock.send('CT')
            print "sent CT"
            print bc
            strLen = len(c_struct)
            self.sock.send(c_struct)
            
            #receive calculated AmpThr
            length =  4		#1 float
            self.smessage.length = length
        
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            self.ampThr[bc] = np.fromstring(data, np.float32, 1)
	
    def initBCOffset(self, bc):
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                'i',
                bc
                )       
            self.sock.settimeout(30)
            self.sock.send('IR')
            print "sent IR"
            print bc
            strLen = len(c_struct)
            self.sock.send(c_struct)
            self.sock.close()
	
    def resetFTOffset(self, bc):
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                'i',
                bc
                )       
            self.sock.settimeout(30)
            self.sock.send('IR')
            print "sent IR"
            print bc
            strLen = len(c_struct)
            self.sock.send(c_struct)
            self.sock.close()

    def champCommand(self):
	print "self.champSetState = ", self.champSetState
	self.initSocket()
	if self.sock != None:
	    c_struct = struct.pack(
		'6i',
		self.champSetState[0], self.champSetState[1], self.champSetState[2],
		self.champSetState[3], self.champSetState[4], self.champSetState[5],
		)       
	    strLen = len(c_struct)
            print strLen
	    self.sock.send('CO')
	    print "sent CO"
	    self.sock.send(struct.pack('L',strLen))
	    self.sock.send(c_struct)
	    self.sock.close()
	
    def getChampStatus(self):
        length =  6*8 + 6*8 + 6*4		#6 doubles 6 doubles 6 int
        self.smessage.length = length
        self.initSocket()
        if self.sock != None:
            self.sock.settimeout(5)
            self.sock.send('CS')
            #self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            self.BCRefOffset = np.fromstring(data[0:48], np.float64, 6)
            self.BCFTOffset = np.fromstring(data[48:96], np.float64, 6)
            self.champState = np.fromstring(data[96:120], np.uint32, 6)
	
    def setBCRefOffset(self):
        self.initSocket()
	if self.sock != None:
            c_struct = struct.pack(
                '6i6d',
                self.toggledBC[0], self.toggledBC[1], self.toggledBC[2],
                self.toggledBC[3], self.toggledBC[4], self.toggledBC[5], 
                self.BCRefOffset[0], self.BCRefOffset[1], self.BCRefOffset[2],
                self.BCRefOffset[3], self.BCRefOffset[4], self.BCRefOffset[5], 
                )       
            strLen = len(c_struct)
            self.sock.send('SR')
            print "sent SR"
            self.sock.send(struct.pack('L',strLen))
            print "sent ", strLen
            print self.BCRefOffset[0], self.BCRefOffset[1], self.BCRefOffset[2], self.BCRefOffset[3], self.BCRefOffset[4], self.BCRefOffset[5]
            self.sock.send(c_struct)
            self.sock.close()
	
#    def initBCRefOffset(self):
#	length =  6*8		#6 doubles 6 doubles 4 int
#        self.smessage.length = length
#        self.initSocket()
#	self.sock.settimeout(30)
#	self.sock.send('IR')
#	self.sock.send(struct.pack('L', self.smessage.length))
#	length = 0
#	data = ''
#	while length < self.smessage.length:
#	    self.smessage.data = self.sock.recv(self.smessage.length-length)
#	    length += len(self.smessage.data)
#	    data += self.smessage.data
#	self.sock.close()
#	self.BCRefOffsets = np.fromstring(data, np.float64, 6)
	
#    def setDelayOffset(self):    #delay offsets in micron
#        self.initSocket()
#	c_struct = struct.pack(
#	    '6i6d',
#	    self.toggledBC[0], self.toggledBC[1], self.toggledBC[2],
#	    self.toggledBC[3], self.toggledBC[4], self.toggledBC[5], 
#	    self.delayOffset[0], self.delayOffset[1], self.delayOffset[2],
#	    self.delayOffset[3], self.delayOffset[4], self.delayOffset[5], 
#	    )
#	strLen = len(c_struct)
#	print strLen
#	self.sock.send('DO')
#	print "sent DO"
#	self.sock.send(struct.pack('L',strLen))
#	print "sent ", strLen
#	self.sock.send(c_struct)
#	self.sock.close()
	
#    def getFringeData(self):
#fluxArr = np.zeros((nbpxFringe, nbFringe), dtype=np.float32)
#        for ndx in range(common.nBL):
#            for npxFringe in range(common.nbpxFringe):
#                common.fluxArr[npxFringe][ndx] = npxFringe*1.
#
#        common.dataFluxReady = 1
#
#        print "RUN getFringeData"

    def killServer(self):
        self.initSocket()
	if self.sock != None:
            self.sock.send('EN')
            self.sock.send(struct.pack('L',1))
            self.sock.send(struct.pack('H',0))
            #data = self.sock.recv(2)
            self.sock.close()
            #print 'Received', repr(data)
